//
//  ViewController.m
//  FirstApp
//
//  Copyright (c) 2012年  OPTO ELECTRONICS Co.,LTD. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
- (IBAction)respondToButtonClick:(id)sender;

@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
    _text = [[NSMutableString alloc] init];
    
    [[EAAccessoryManager sharedAccessoryManager] registerForLocalNotifications];

    // Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    _service = [OPN2002iBluetoothService sharedController];
    [_service setDelegate:self];
    
    [_service openSession];
    [_service setEnableReadBarcode:OPN2002I_READBORCODE_ENABLE];

    textView.text = @"";
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(_accessoryDidConnect:)
                                                 name:EAAccessoryDidConnectNotification
                                               object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(_accessoryDidDisconnect:)
                                                 name:EAAccessoryDidDisconnectNotification
                                               object:nil];
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];

    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:EAAccessoryDidConnectNotification
                                                  object:nil];
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:EAAccessoryDidDisconnectNotification
                                                  object:nil];
}


- (BOOL)openAccessory
{
    //接続中のAccessoryを取得
    NSArray *accessoryList = [[NSMutableArray alloc] initWithArray:
                              [[EAAccessoryManager sharedAccessoryManager] connectedAccessories]];
    
    if(accessoryList == nil || accessoryList.count == 0) return NO;
    EAAccessory *accessory = [accessoryList lastObject];
    
    OPN2002iBluetoothService *s = [OPN2002iBluetoothService sharedController];
    
    NSArray *protocolStrings = [accessory protocolStrings];
    
    if(protocolStrings == nil || [protocolStrings count]==0) return NO;
    
    NSString *protocolString = [protocolStrings objectAtIndex:0];
    for (int i = 0; i<3; i++) {
        //sleep(1);
        [s setupControllerForAccessory:accessory
                    withProtocolString:protocolString];
        if([s openSession]){
            break;
        }
        sleep(1);
    }
    
    s.delegate = self;
    
    if(!_service.accessory.isConnected){
        UIAlertView *alert = [[UIAlertView alloc]
                              initWithTitle:@""
                              message:@"データコレクターと接続されていません。"
                              delegate:nil
                              cancelButtonTitle:@"OK"
                              otherButtonTitles:nil];
        [alert show];
        return NO;
    }
    
    return YES;
}

- (IBAction)respondToButtonClick:(id)sender
{
    [_service openSession];
    _service.delegate = self;

    if(_service.accessory.isConnected){
    }
    else {
        [self openAccessory];
    }

    [_service getFirmwareVersion:self];

}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}

- (void)bluetoothService:(OPN2002iBluetoothService *)service didGetFirmware:(NSData *)data
{
    NSString *str = [[NSString alloc] initWithData:data encoding:NSShiftJISStringEncoding];

    UIAlertView *alert = [[UIAlertView alloc] 
                          initWithTitle:@"" 
                          message:str
                          delegate:nil 
                          cancelButtonTitle:@"OK" 
                          otherButtonTitles:nil];
    [alert show];    
}


- (void)_accessoryDidConnect:(NSNotification *)notification
{
    OPN2002iBluetoothService *sessionController = [OPN2002iBluetoothService sharedController];
    if(sessionController.accessory.isConnected){

    }
    else{
        [self openAccessory];
    }
}

- (void)_accessoryDidDisconnect:(NSNotification *)notification
{

}

#pragma mark - BluetoothService Delegate


- (void)bluetoothService:(OPN2002iBluetoothService *)service didGetBarcode:(NSData *)data
{
     NSString *str = [[NSString alloc] initWithData:data encoding:NSShiftJISStringEncoding];
    [_text appendFormat:@"%@",str];
    textView.text = _text;
    NSRange range = NSMakeRange(textView.text.length - 1, 1);
    [textView scrollRangeToVisible:range];
    str = nil;
}



@end
