﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Collections;

using OPNTermComDllLib;

namespace FirstAppCSharp
{
    public partial class Form1 : Form
    {
        private WOPN2002iBluetoothService kService = new WOPN2002iBluetoothService();
        private List<WOPNBluetoothDevice> lstDevices = new List<WOPNBluetoothDevice>(); //  デバイス検索結果一覧

        public Form1()
        {
            InitializeComponent();

            // 初期化
            kService.Initialize();

            kService.OnDidGetFirmwareEvent += kService_OnDidGetFirmwareEvent;
            kService.OnReceiveBarcodeEvent += kService_OnReceiveBarcodeEvent;
            kService.OnDidConnectDeviceEvent += kService_OnDidConnectDeviceEvent;
            kService.OnDidDisconnectDeviceEvent += kService_OnDidDisconnectDeviceEvent;
            kService.OnDidDiscoveredDeviceEvent += kService_OnDidDiscoveredDeviceEvent;
            kService.OnRequestPinCodeEvent += kService_OnRequestPinCodeEvent;
        }

        bool kService_OnRequestPinCodeEvent(out string pszPinCode)
        {
            Console.WriteLine("OnRequestPinCodeEvent");
            pszPinCode = "1234";
            return true;
        }

        void kService_OnDidDiscoveredDeviceEvent(WOPNBluetoothDevice pDevice)
        {
            searchDeviceListBox.Invoke((MethodInvoker)delegate
            {
                if( pDevice != null ) {
                    lstDevices.Add(pDevice);
                    searchDeviceListBox.Items.Add(pDevice.Name + "\t" + pDevice.Address);
                }
            });
        }

        void kService_OnReceiveBarcodeEvent(object data)
        {
            terminalTextBox.Invoke((MethodInvoker)delegate
            {
                Console.WriteLine("kService_OnReceiveBarcodeEvent");
                if (data != null)
                {
                    String str = Encoding.ASCII.GetString((byte[])data).Replace("\r", "\r\n");
                    terminalTextBox.AppendText(str);
                }
            });
        }

        void kService_OnDidConnectDeviceEvent(WOPNBluetoothDevice pDevice)
        {
            MessageBox.Show("接続されました。");
        }

        void kService_OnDidDisconnectDeviceEvent(WOPNBluetoothDevice pDevice)
        {
            MessageBox.Show("切断されました。");
        }

        void kService_OnDidGetFirmwareEvent(object data)
        {
            terminalTextBox.Invoke((MethodInvoker)delegate
            {
                Console.WriteLine("kService_OnDidGetFirmwareEvent");

                String buff = Encoding.ASCII.GetString((byte[])data);
                String str = buff.Replace("\r", "\r\n").Replace((char)0x06,'\0');
                terminalTextBox.AppendText(str);
            });
        }

        private void SearchDeviceButton_Click(object sender, EventArgs e)
        {
            searchDeviceListBox.Items.Clear();
            kService.DoDiscoveryAsync();
        }

        private void ConnectSlaveButton_Click(object sender, EventArgs e)
        {
            int sl = searchDeviceListBox.SelectedIndex;
            if (sl >= 0)
            {
                // PINコードを設定
                WOPNBluetoothDevice device = lstDevices[sl];
                WOPNResult success = kService.Connect(device, true);
            }
        }

        private void ConnectMasterButton_Click(object sender, EventArgs e)
        {
            kService.StartServer();
        }

        private void DisconnectButton_Click(object sender, EventArgs e)
        {
            kService.Disconnect();
        }

        private void GetFirmwareVerButton_Click(object sender, EventArgs e)
        {
            kService.GetFirmwareVersion();
        }

        private void BuzzerOnButton_Click(object sender, EventArgs e)
        {
            kService.PushCommand("P3");
            kService.PushCommand("B");
            kService.StartSendCommands();
        }

    }
}
