#ifndef OPNTERMLIB_BTHSPPCONNECTION_H_
#define OPNTERMLIB_BTHSPPCONNECTION_H_

#include "BTHCore.h"

/// O錾
class BTHSppConnection;
class BTHReadCondition;

/**
* @class BTHSppConnectionDelegate
* @brief BTHSppConnection̈ϏC^[tF[X
*/
class IBTHSppConnectionDelegate
{
public:

  /**
  * @brief f[^ǂݍޒOɌĂяo郁\bh
  * @param[in] pConnection BTHSppConnectioñCX^X
  * @param[in,out] pReadCondition Ǎin[AI[w\j
  */
  virtual BOOL OnWillReadData( 
    BTHSppConnection *pConnection,
    BTHReadCondition *pReadCondition
    ) = 0;

  /**
  * @brief f[^ǂݍ񂾏ꍇɌĂяo郁\bh
  * @param[in] pConnection BTHSppConnectioñCX^X
  * @param[in] readData ǂݍ񂾃f[^
  * @param[in] readBytes ǂݍ񂾃f[^̃oCg
  * @return TRUEAsFALSEԂ܂B
  */
  virtual BOOL OnDidReadData( 
    BTHSppConnection *pConnection, 
    BYTE *readData, 
    INT readBytes
    ) = 0;

  /**
  * @brief foCXƂ̐ڑɌĂяo郁\bh
  * @param[in] pConnection BTHSppConnectioñCX^X
  */
  virtual VOID OnDidConnectDevice( BTHSppConnection *pConnection ) = 0;

  /**
  * @brief foCXƂ̐ؒfɌĂяo郁\bh
  * @param[in] pConnection BTHSppConnectioñCX^X
  */
  virtual VOID OnDidDisconnectDevice( BTHSppConnection *pConnection ) = 0;
};

/**
* @class BTHSppConnection
* @brief ڑێNX
*/
class BTHSppConnection
{
public:
  /// RXgN^
  BTHSppConnection(void);
  /// fXgN^
  ~BTHSppConnection(void);

  /**
  * @brief fQ[gݒ肵܂B@
  * @param[in] pDelegate IBTHSppClientDelegatẽCX^X
  */
  VOID SetDelegate( IBTHSppConnectionDelegate *pDelegate ); 

  /**
  * @brief ڑmF܂B
  * @return ڑȂTRUEAȊOȂFALSEԂ܂B
  */
  BOOL IsConnected();

  /**
  * @brief ؒf܂B
  * @return ̏ꍇ BTHCORE_SUCCESS Ԃ܂B
  */
  LONG Disconnect();

  /**
  * @brief ڑ̃\PbgɃf[^݂܂B
  * @param[in] writeData ރoCgz̐擪|C^
  * @param[in] toWriteBytes writeDatãoCg
  * @param[in] nTimeout ^CAEgibj
  * @return ̏ꍇ 񂾃oCgԂ܂Bs̏ꍇ -1 Ԃ܂B
  */
  LONG WriteData( BYTE *writeData, int toWriteBytes, int nTimeout );

  /**
  * @brief ڑBluetoothfoCX擾܂B
  * @param[out] pbtdi BLUETOOTH_DEVICE_INFÕ|C^
  * @return ̏ꍇ BTHCORE_SUCCESS Ԃ܂B
  */
  LONG GetConnectedBthDeviceInfo( PBLUETOOTH_DEVICE_INFO pbtdi );

  /**
  * @brief ǂݍݗpXbhJn܂B
  * @param[in] sd \Pbg
  * @param[in] btdi foCX
  * @return ̏ꍇ BTHCORE_SUCCESS Ԃ܂B
  */
  LONG StartReadThread( SOCKET sd, BLUETOOTH_DEVICE_INFO btdi );

private:
  /// PimplCfBIiRs[֎~j
  class Impl;
  Impl *m_impl;
  /// Rs[RXgN^
  BTHSppConnection( const BTHSppConnection& instance );
  /// ZqɂRs[
  BTHSppConnection& operator= (const BTHSppConnection& instance );
};


/**
* @class ReadCondition
* @brief ǂݍݏw肷NX
*/
class BTHReadCondition {
public:
  // RXgN^
  BTHReadCondition() 
    : StartByte(NULL)
    , EndByte(NULL)
    , IsAllRead(TRUE) {};
  // fXgN^
  ~BTHReadCondition() {};

  BYTE StartByte;   //<! n[
  BYTE EndByte;     //<! I[
  BOOL IsAllRead;   //<! n[EI[𖳎ăf[^ׂēǂݍޏꍇTRUE
};

#endif //OPNTERMLIB_BTHSPPCONNECTION_H_
