//
// Copyright (c) 2013 OPTOELECTRONICS CO., LTD. All rights reserved
//

#ifndef OPNTERMLIB__OPNBLUETOOTHSERVICE_H_
#define OPNTERMLIB__OPNBLUETOOTHSERVICE_H_

#include "stdafx.h"
#include <WinSock2.h>
#include <ws2bth.h>

#pragma warning(disable:4068)
#include <BluetoothAPIs.h>
#pragma warning(default:4068)

#include <functional>
#include <queue>

#include "OPNBluetoothDevice.h"
#include "OPNErrors.h"

#pragma comment(lib,"ws2_32.lib")

class BTHSppConnection;
class BTHReadCondition;
class BTHSppServer;
class BTHSppClient;
class BTHAutoConnect;

class OPNBluetoothService;
class OPNBluetoothDevice;
class OPNBluetoothHostInfo;

/**
* @enum OPNAutoConnectStatus
* @brief X[u̎ڑ̏Ԃ萔
*/
typedef enum OPNAutoConnectStatus {
  OPN_AUTO_CONNECT_STATUS_STOP = 0,   //<! ~
  OPN_AUTO_CONNECT_STATUS_RUNNING,    //<! s
  OPN_AUTO_CONNECT_STATUS_CONNECTING, //!< ڑs
  OPN_AUTO_CONNECT_STATUS_CONNECTED   //!< ڑ
} OPNAutoConnectStatus;

/**
* @class IOPNBluetoothServiceDelegate
* @brief OPNBluetoothServiceɑ΂fQ[^NX
*
* ̃NXpĊe\bhI[o[Ch邱ƂŁA
* OPNBluetoothServiceNX̃Cxg󂯎邱Ƃł܂B
* pNX̃CX^XOPNBuetoothServiceSetDelegate\bh
* ݒ肵ĂB
* SetDelegateŐݒ肵fQ[^͏㏑܂B
* ̃NXSetDelegateɍĂуCxg󂯎悤ɂɂ́A
* SetDelegatexsĂB
*/
class IOPNBluetoothServiceDelegate
{
public:

	/**
	* @brief OPNfoCXڑƌĂяo܂
	* @param[in] pService ڑOPNBluetoothServiceNX̃CX^X
	* @param[in] pDevice ڑꂽfoCX̃CX^X
	*/
	virtual VOID OnDidConnectDevice( 
    OPNBluetoothService *pService, 
    OPNBluetoothDevice* pDevice ) {};

	/**
	* @brief OPNfoCXؒfƌĂяo܂
	* @param[in] pService ڑOPNBluetoothServiceNX̃CX^X
	* @param[in] pDevice ڑꂽfoCX̃CX^X
	*/
	virtual VOID OnDidDisconnectDevice( 
    OPNBluetoothService *pService, 
    OPNBluetoothDevice* pDevice ) {};

	/**
	* @brief DoDiscoveryAsync \bhŃfoCX1䔭ƌĂяo܂
	* @param[in] pService ڑOPNBluetoothServiceNX̃CX^X
	* @param[in] pDevice foCX̃CX^X
	*/
	virtual VOID OnDidDiscoveredDevice( 
    OPNBluetoothService *pService, 
    OPNBluetoothDevice pDevice ) {};

	/**
	* @brief DoDiscoveryAsync \bhŃfoCXTƌĂяo܂
	* @param[in] pService ڑOPNBluetoothServiceNX̃CX^X
	* @param[in] iDeviceCount [̑䐔
	*/
	virtual VOID OnCompleteDiscovery( 
    OPNBluetoothService *pService, 
    INT iDeviceCount ) {};

	/**
	* @brief o[R[hMƌĂяo܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[in] pData Mf[^
	*/
	virtual VOID OnReceiveBarcode( 
    OPNBluetoothService *pService, 
    BYTE* pData ) {};

  /**
  * @brief FؒPINR[hKvƂȂꍇɌĂяo܂B
	* @param[in] pService OPNBluetoothServicẽCX^X
	* @param[out] lpszPinCode PINR[hݒ肵܂
  * @return TRUEAsFALSEw肵܂B
  */
  virtual BOOL OnRequestPinCode(
    OPNBluetoothService *pService,
    LPSTR lpszPinCode
    ) { return FALSE; };
};

/**
 * @class OPNBluetoothService
 * @brief OPNfoCXƂ̐ڑAf[^MǗ钊ۃNX
 *
 * OPNBluetoothServiceNX́AOPN2002x, OPN3002xƂ̃yAOA
 * X[u/}X^[ڑAf[^M̋@\𓋍ڂۃNXłB
 * p OnWillReadData/OnDidReadData Kv܂B
 */
class OPNBluetoothService 
{
public:

	/**
	* @brief OPNBluetoothServicẽfQ[^ݒ肵܂B
	* @param pDelegate fQ[^
	*/
	VOID SetDelegate( IOPNBluetoothServiceDelegate *pDelegate );

	/** @name f[^̑M
	*  @brief f[^𑗎M邽߂̃\bhłB
	*/
	//@{

	/** 
	* @brief ACK𑗐M܂B
	* @return 񂾃f[^̃oCgԂ܂Bsꍇ-1Ԃ܂B
	*/
	LONG WriteACK();

	/** 
	* @brief NAK𑗐M܂B
	* @return 񂾃f[^̃oCgԂ܂Bsꍇ-1Ԃ܂B
	*/
	LONG WriteNAK();

	/**
	* @brief o[R[hRN^[ɃoCif[^𑗐M܂B
	* @param[out] writeData o[R[hRN^[̎Mf[^
	* @param[in] toWriteBytes bytẽobt@TCY
	* @param[in] nTimeout ^CAEgԁimsjw肵Ȃꍇ5bB
	* @return 񂾃f[^̃oCgԂ܂Bsꍇ-1Ԃ܂B
	*/
	LONG WriteData( BYTE *writeData, INT toWriteBytes, INT nTimeout = 5000 );

	/**
	* @brief o[R[hRN^[ɃoCif[^𑗐M܂B
	* ʐMReadBarcodeMꍇANakԂ܂B
	* @param[in] writeData Mf[^
	* @param[in] toWriteBytes Mf[^
	* @param[in] nTimeout ^CAEgԁimsjw肵Ȃꍇ5bB
	* @return 񂾃f[^̃oCgԂ܂Bsꍇ-1Ԃ܂B
	*/
	LONG WriteDataReadBarcodeResponseNak( 
    BYTE *writeData, 
    INT toWriteBytes, 
    INT nTimeout = 5000 );

	//@}


	/** @name }X^[/X[uڑ
	*  @brief T[o̊JnEIANCAg̐ڑEؒf\bhłB
	*/
	//@{

	/**
	* @brief w肵foCXɃNCAgƂĐڑ܂B
	* @param[in] opnDevice ڑΏۂOPNBluetoothDevicew肵܂B
	* @param[in] bSecure ZLAڑ̏ꍇTRUEA
  * CZLAڑ̏ꍇFALSEw肵܂B
	* @return G[Ԃ܂B̏ꍇ OPN_SUCCESS Ԃ܂B
	*/
	OPNResult Connect( OPNBluetoothDevice opnDevice, BOOL bSecure );

	/**
	* @brief foCXؒf܂B
	* @return G[Ԃ܂B̏ꍇ OPN_SUCCESS Ԃ܂B
	*/
	OPNResult Disconnect();

	/**
	* @brief T[o[Jn܂B
	* @return G[Ԃ܂B̏ꍇ OPN_SUCCESS Ԃ܂B
	*/
	OPNResult StartServer();

	/**
	* @brief T[o[~܂B
	* @return G[Ԃ܂B̏ꍇ OPN_SUCCESS Ԃ܂B
	*/
	OPNResult StopServer();

	/**
	* @brief ڑς݂̏ꍇTRUEԂ܂B
	* @return ڑς݂̏ꍇTRUEԂ܂BȊOFALSEԂ܂B
	*/
	BOOL IsConnected();

	/**
	* @brief T[oƂĐڑĂꍇTRUEԂ܂B
	* @return T[oƂĐڑĂꍇTRUEԂ܂B
  * ȊOFALSEԂ܂B
	*/
	BOOL IsServerConnected();

  /**
	* @brief X[uڑs̏ꍇTRUEԂ܂B
	* @return X[uڑs̏ꍇTRUEԂ܂B
  * ȊOFALSEԂ܂B
	*/
	OPNAutoConnectStatus GetAutoConnectStatus();

  /**
  * @brief ڑΏۂ̃foCXԂ܂B
  * @return ̏ꍇ OPN_SUCCESS Ԃ܂B
  */
  OPNResult GetAutoConnectDevice( OPNBluetoothDevice *pOpnDevive );

  /**
  * @brief X[u̎ڑJn܂B
  * @return ̏ꍇ OPN_SUCCESS Ԃ܂B
  */
  OPNResult StartAutoConnect();

  /**
  * @brief X[u̎ڑI܂B
  * @return ̏ꍇ OPN_SUCCESS Ԃ܂B
  */
  OPNResult StopAutoConnect();

	//@}

	/** @name Bluetooth
	*  @brief BluetoothfoCX֘Ã\bhłB
	*/
	//@{

	/**
	* @brief PCBluetoothT|[gĂ邩ǂ擾܂B
	* @return T|[gLłTRUEAłFALSEԂ܂B
	*/
	OPNResult IsBluetoothEnabled();

	/**
	* @brief BluetoothfoCX猟\ȏԂǂ擾܂B
	* @return \ȏԂłTRUEBłȂFALSEB
	*/
	BOOL IsDiscoverable();

	/**
	* @brief yAOς݂BluetoothfoCX擾܂B
	* @param[out] devices 擾foCX̔z
	* @param[out] nCount 擾foCX
	* @return ł OPN_SUCCESS ԂB
	*/
	OPNResult GetPairedDevices( OPNBluetoothDevice devices[], INT &nCount );

	/**
	* @brief ӂBluetoothfoCX܂B
	*
	* @param[out] devices 擾foCX̔z
	* @param[out] nCount 擾foCX
	* @return ł OPN_SUCCESS ԂB
	*/
	OPNResult DoDiscovery( OPNBluetoothDevice devices[], INT &nCount );

	/**
	* @brief ӂBluetoothfoCX񓯊Ō܂B
	*
	* ̃\bh͔񓯊ŏs܂B
	* foCX1䔭ƁAOnDidDiscoveredDevice Ăяo܂B
	* ƁAOnCompleteDiscovery Ăяo܂B
	* ɌJnĂꍇ́AsOɌLZ܂B
	*
	* @return ł OPN_SUCCESS ԂB
	*/
	OPNResult DoDiscoveryAsync();

	/**
	* @brief DoDiscoveryAsync\bhɂfoCXLZ܂B
	*/
	VOID CancelDiscovery();

	//@}

	/**
	* @brief ReadBarcode̋E֎~ݒ肵܂B
	* @param[in] bEnabled ̏ꍇTRUEA֎~̏ꍇFALSE
	*/
	VOID SetEnableReadBarcode( BOOL bEnabled );

	/**
	* @brief ݂ReadBarcode֎~Ԃ܂B
	* @return TRUE:AFALSE:֎~
	*/
	BOOL IsEnableReadBarcode();

  /**
	* @brief ڑς݂̃foCX擾܂B
	* @param[out] pOpnDevice foCX̃|C^ 
  * @return ȂOPN_SUCCESSԂ܂B
  */
  OPNResult GetConnectedBluetoothDevice( OPNBluetoothDevice *pOpnDevice );

  /**
  * @brief Bluetooth̃zXg擾܂B
  * @param[out] pHosts OPNBluetoothHostInfo̔z
  * @param[out] nCount 擾OPNBluetoothHostInfǒ
  * @return 擾FOPN_SUCCESS
  */
  OPNResult GetBluetoohHostInfos( OPNBluetoothHostInfo pHosts[], INT &nCount );

  /**
  * @brief f[^MǍJn钼OŌĂяoC^[tF[XłB
  * @param[in] pConnection BTHSppConnectionNX̃CX^Xւ̃|C^
  * @param[out] pReadCondition Ǎw肵܂B
  * @return TRUEAsFALSEԂ悤ɂ܂B
  */
  virtual BOOL OnWillReadData( 
    BTHSppConnection *pConnection,
    BTHReadCondition *pReadCondition
    ) = 0;

  /**
  * @brief f[^̓ǍŌĂяoC^[tF[XłB
  * @param[in] pConnection BTHSppConnectionNX̃CX^Xւ̃|C^
  * @param[in] readData ǂݍ񂾃f[^
  * @param[in] readBytes ǂݍ񂾃f[^̃oCg
  * @return TRUEAsFALSEԂ悤ɂ܂B
  */
  virtual BOOL OnDidReadData( 
    BTHSppConnection *pConnection, 
    BYTE *readData, 
    INT readBytes
    ) = 0;
  
protected:

	/**
	* @brief RXgN^
	*/
	OPNBluetoothService();
	
	/**
	* @brief Rs[RXgN^
	* @param[in] instance Rs[
	*/
	OPNBluetoothService( const OPNBluetoothService &instance );

	/**
	* @brief fXgN^
	*/
	~OPNBluetoothService();

  /**
  * @brief fQ[^擾܂B
  * @return IOPNBluetoothServiceDelegateNX̃CX^Xւ̃|C^
  */
  IOPNBluetoothServiceDelegate* GetDelegate();

private:
  /// PimplCfBIɂNX
	class Impl;
  /// ImplNX̃CX^Xւ̃|C^
	Impl *m_impl;

};

#endif //OPNTERMLIB__OPNBLUETOOTHSERVICE_H_