//
// Copyright (c) 2013 OPTOELECTRONICS CO., LTD. All rights reserved
//

#ifndef OPNTERMDESKTOP__OPNSETTINGS_H_
#define OPNTERMDESKTOP__OPNSETTINGS_H_

#include "stdafx.h"

#include "OPNSettingFormat.h"
#include "OPNSettingChars.h"

/**
* @class OPNSettings
* @brief f[^RN^[擾oCgf[^̐ݒl擾邽߂̃\bh񋟂܂B
*
* [GoF]Singletonp^[gĂ邽߁ACX^X͂P܂B
* CX^X̎擾ɂ́AGetInstance(void)gpĂB
*  Rs[RXgN^privateĂ̂ŁACX^X̕łȂ悤ɂȂĂ܂B
* |C^ł͂ȂQƂԂ̂ŁAdelete͕svłB
* }`XbhS͂܂B
* vZXIɁAj܂B
*/
class OPNSettings
{
private:
	/// @brief t@[o[W
	UINT16 m_formatVersion;
	/// @brief xsw
	OPNSettingXSW m_xswData;
	/// @brief btData
	OPNSettingBT m_btData;
	/// @brief prefixSuffix
	OPNSettingPrefixSuffix m_prefixSuffixData;
	/// @brief prefixSuffix
	OPNSettingPrefixSuffix2 m_prefixSuffixData2;
	/// @brief RXgN^
	OPNSettings();

public:
	/// @brief RXgN^
	OPNSettings(BYTE *data);
	/// @brief fXgN^
	~OPNSettings();

	/**
	* @brief GetSettingŎ擾f[^ŏ܂B
	* @param byte GetSettingŎ擾f[^
	*/
	void SetSettingData(BYTE *byte);

	/**
	* @brief t@[EFAo[W擾܂B
	* @return t@[EFAo[W
	*/
	UINT16 GetFormatVersion();

	/**
	* @brief EAN-13/8̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL JAN_EAN_13_8_PERMISSION();

	/**
	* @brief EAN-13CD]Ɋւݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL JAN_EAN_13_TRANSMIT_CD();

	/**
	* @brief WPCiUPCAEANAJANjCDvZɊւݒ擾܂B
	* @return YES:CDvZ NO:CDvZȂ
	*/
	BOOL WPC_UPC_EAN_JAN_CD_CALCULATION();//XSW5,6,7,8

	/**
	* @brief EAN-13/8iAddon2j̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL JAN_EAN_13_8_ADDON2_PERMISSION();

	/**
	* @brief EAN-13/8iAddon5j̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL JAN_EAN_13_8_ADDON5_PERMISSION();

	//--------------------------------------------------------------------------------------------------
	// XSW6
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief JAN/EAN-8CD]Ɋւݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL JAN_EAN_8_TRANSMIT_CD();


	//--------------------------------------------------------------------------------------------------
	// XSW7
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief UPC-A/E̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL UPC_A_E_PERMISSION();

	/**
	* @brief UPC-ACD]Ɋւݒ擾܂B
	* @return xsw7 2bit
	*/
	BOOL UPC_A_TRANSMIT_CD_B2();

	/**
	* @brief UPC-ACD]Ɋւݒ擾܂B
	* @return xsw7 4bit
	*/
	BOOL UPC_A_TRANSMIT_CD_B4();

	/**
	* @brief UPC-A/EiAddon2j̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL UPC_A_E_Addon2_PERMISSION();

	/**
	* @brief UPC-A/EiAddon5j̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL UPC_A_E_Addon5_PERMISSION();

	/**
	* @brief UPC-ACD]Ɋւݒ擾܂B
	* @return 
	*  1:PRi擪OƂbctj<br/>
	*  2:PQi擪OȂj<br/>
	*  3:PQibcȂj<br/>
	*  0:PPi擪OƂbcȂj<br/>
	*/
	int UPC_A_TRANSMIT();

	//--------------------------------------------------------------------------------------------------
	// XSW8
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief UPC-ECD]Ɋւݒ擾܂B
	* @return xsw8 2bit
	*/
	BOOL UPC_E_TRANSMIT_CD_B2();

	/**
	* @brief UPC-ECD]Ɋւݒ擾܂B
	* @return xsw8 4bit
	*/
	BOOL UPC_E_TRANSMIT_CD_B4();

	/**
	* @brief UPC-ECD]Ɋւݒ擾܂B
	* @return
	* 1:Wi擪OƂbctj<br/>
	* 2:Vi擪Ȃj<br/>
	* 3:VibcȂj<br/>
	* 0:Ui擪OƂbcȂj<br/>
	*/
	int UPC_E_TRANSMIT();

	//--------------------------------------------------------------------------------------------------
	// XSW9
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief Code39̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CODE_39_PERMISSION();

	/**
	* @brief Code39̓ǎ拖ݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL CODE_39_TRANSMIT_CD();

	/**
	* @brief Code39CDvZɊւݒ擾܂B
	* @return YES:CDvZ NO:CDvZȂ
	*/
	BOOL CODE_39_CALCULATION();

	/**
	* @brief Code39̃X^[gXgbvɊւݒ擾܂B
	* @return YES:] NO:]Ȃ
	*/
	BOOL CODE_39_START_STOP_CD();

	//--------------------------------------------------------------------------------------------------
	// XSW10
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief NW-7̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL NW_7_PERMISSION();

	/**
	* @brief NW-7̓ǎ拖ݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL NW_7_TRANSMIT_CD();

	/**
	* @brief NW-7CDvZɊւݒ擾܂B
	* @return
	* 1: CDvZ Mod10/W1,2 spec1<br/>
	* 2: CDvZ Mod16<br/>
	* 3: CDvZ 7 check<br/>
	* 4: CDvZ Mod11<br/>
	* 0: CDvZȂ<br/>
	*/
	int NW_7_CALCULATION();

	/**
	* @brief NW-7̃X^[gXgbvɊւݒ擾܂B
	* @return
	* 1: ] ABCD/TN*E<br/>
	* 2: ] abcd/tn*e<br/>
	* 3: ] ABCD<br/>
	* 4: ] abcd<br/>
	* 5: ] DC1DC2DC3DC4<br/>
	* 0: ]Ȃ<br/>
	*/
	int NW_7_START_STOP_CD();


	//--------------------------------------------------------------------------------------------------
	// XSW11
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief Interleaved2of5̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL INTERLEAVED_2OF5_PERMISSION();

	/**
	* @brief Industrial 2 of 5/Interleaved 2 of 5CD]Ɋւݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL INDUSTRIAL_INTERLEAVED_2OF5_TRANSMIT_CD();

	/**
	* @brief Industrial 2 of 5/Interleaved 2 of 5CDvZɊւݒ擾܂B
	* @return YES:CDvZ NO:CDvZȂ
	*/
	BOOL INDUSTRIAL_INTERLEAVED_2OF5_CALCULATION();

	/**
	* @brief Industrial2of5̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL INDUSTRIAL_2OF5_PERMISSION();


	//--------------------------------------------------------------------------------------------------
	// XSW12
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief IATA̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL IATA_PERMISSION();

	/**
	* @brief IATACD]Ɋւݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL IATA_TRANSMIT_CD();

	/**
	* @brief IATACDvZɊւݒ擾܂B
	* @return
	* 1: C/DvZ (CPN+FORM SERIAL)<br/>
	* 2: C/DvZ (FORM SERIAL)<br/>
	* 3: C/DvZ (ALL DATA)<br/>
	* 0: C/DvZȂ<br/>
	*/
	int IATA_CALCULATION();

	/**
	* @brief Code93̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CODE_93_PERMISSION();

	/**
	* @brief Code93CDvZɊւݒ擾܂B
	* @return YES:CDvZ NO:CDvZȂ
	*/
	BOOL CODE_93_CALCULATION();

	//--------------------------------------------------------------------------------------------------
	// XSW13
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief Code128̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CODE_128_PERMISSION();

	/**
	* @brief Code128CD]Ɋւݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL CODE_128_TRANSMIT_CD();

	/**
	* @brief Code 128/EAN-128CDvZɊւݒ擾܂B
	* @return YES:CDvZ NO:CDvZȂ
	*/
	BOOL CODE_128_EAN_128_CALCULATION();

	/**
	* @brief Code128̓ǎ拖ݒ擾܂B
	* @return 
	* 2: @if Possible<br/>
	* 1: @EAN-128 Only<br/>
	* 0: ֎~@Code 128Ƃďo<br/>
	*/
	int EAN_128_PERMISSION();

	/**
	* @brief SCode̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL S_CODE_PERMISSION();

	//--------------------------------------------------------------------------------------------------
	// XSW14
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief MSI/Plessey̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL MSI_PLESSEY_PERMISSION();

	/**
	* @brief MSI/PlesseyCD]Ɋւݒ擾܂B
	* @return 
	* 1:CD] CD1<br/>
	* 2:CD] CD1 and CD2<br/>
	* 0:CD]Ȃ
	*/
	int MSI_PLESSEY_TRANSMIT();

	/**
	* @brief MSI/PlesseyCDvZɊւݒ擾܂
	* @return 
	* 1:C/DvZ CD1 only (Mod10)<br/>
	* 2:C/DvZ CD's (Mod10/Mod10)<br/>
	* 3:C/DvZ CD's (Mod10/Mod11)<br/>
	* 4:C/DvZ CD's (Mod11/Mod10)<br/>
	* 0:C/DvZȂ
	*/
	int MSI_PLESSEY_CALCULATION();
	/**
	* @brief Code128̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL UK_PLESSEY_PERMISSION();

	//--------------------------------------------------------------------------------------------------
	// XSW15
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief Telepen̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL TELEPEN_PERMISSION();

	/**
	* @brief Matrix2of5̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL MATRIX_2OF5_PERMISSION();

	/**
	* @brief Tri-Optic̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL TRI_OPTIC_PERMISSION();

	//--------------------------------------------------------------------------------------------------
	// XSW16
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief GS1 DataBar ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL GS1_DATABAR_RSS14_PERMISSION();
	/**
	* @brief GS1 DataBar Limited ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL GS1_DATABAR_LIMITED_PERMISSION();
	/**
	* @brief GS1 DataBar Expanded ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL GS1_DATABAR_EXPANDED_PERMISSION();

	/**
	* @brief GS1 DataBarCD]Ɋւݒ擾܂B
	* @return YES:CD] NO:CD]Ȃ
	*/
	BOOL GS1_DATABAR_TRANSMIT_CD();


	//--------------------------------------------------------------------------------------------------
	// XSW17
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief Code 3 of 5 ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CODE_3OF5_PERMISSION();


	//--------------------------------------------------------------------------------------------------
	// XSW19
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief MicroPDF417 ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL MICRO_PDF_417_PERMISSION();
	/**
	* @brief PDF417 ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL PDF_417_PERMISSION();
	/**
	* @brief Code11 ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CODE_11_PERMISSION();

	//--------------------------------------------------------------------------------------------------
	// XSW26
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief IntelligentMail ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL INTELLIGENT_MAIL_PERMISSION();
	/**
	* @brief Postnet ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL POSTNET_PERMISSION();
	/**
	* @brief Japanese Postal ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL JAPANESE_POSTAL_PERMISSION();
	/**
	* @brief CodablockF ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CODABLOCK_F_PERMISSION();
	/**
	* @brief Data Matrix(ECC200) ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL DATA_MATRIX_ECC200_PERMISSION();
	/**
	* @brief Data Matrix(ECC000-140) ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL DATA_MATRIX_ECC000_140_PERMISSION();
	/**
	* @brief Aztec code ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL AZTEC_CODE_PERMISSION();
	/**
	* @brief Aztec runes ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL AZTEC_RUNES_PERMISSION();
	/**
	* @brief Chinese Sensible code ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL CHINESE_SENSIBLE_CODE_PERMISSION();
	/**
	* @brief QR code ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL QR_CODE_PERMISSION();
	/**
	* @brief MicroQR code ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL MICRO_QR_CODE_PERMISSION();
	/**
	* @brief Maxi code ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL MAXI_CODE_PERMISSION();
	/**
	* @brief Composite on GS1 Databar ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL COMPOSITE_ON_GS1_DATABAR_PERMISSION();
	/**
	* @brief Composite on UPC/EAN ̓ǎ拖ݒ擾܂B
	* @return YES: NO:֎~
	*/
	BOOL COMPOSITE_ON_UPC_EAN_PERMISSION();

	//--------------------------------------------------------------------------------------------------
	// Public Methods(BT)
	//--------------------------------------------------------------------------------------------------
	/**
	* @brief ǂݎ胂[h̐ݒ擾܂B
	* @return 
	* 1:Pǂ<br/> 
	* 2:ǂ<br/> 
	* 3:Aǂ
	*/
	int READ_MODE();
	/**
	* @brief ǂݎ莞Ԃ̐ݒ擾܂B
	* @return
	* 0  :<br/>
	* -1 :0b<br/>
	* 50 :1b<br/>
	* 100:2b<br/>
	* 150:3b<br/>
	* 200:4b<br/>
	* 250:5b<br/>
	* 300:6b<br/>
	* 350:7b<br/>
	* 400:8b<br/>
	* 450:9b<br/>
	* Ԃl x 10 = ǂݎ莞ԁi~bj
	*/
	int READABLE_TIME();
	/**
	* @brief ƍ񐔂̐ݒ擾܂B
	* @return
	*  0: 1ǎ  0ƍ<br/>
	*  1: 2ǎ  1ƍ<br/>
	*  2: 3ǎ  2ƍ<br/>
	*  3: 4ǎ  3ƍ<br/>
	*  4: 5ǎ  4ƍ<br/>
	*  5: 6ǎ  5ƍ<br/>
	*  6: 7ǎ  6ƍ<br/>
	*  7: 8ǎ  7ƍ<br/>
	*  8: 9ǎ  8ƍ<br/>
	*  9:10ǎ  9ƍ<br/>
	* 10:11ǎ 10ƍ<br/>
	* 11:12ǎ 11ƍ<br/>
	* 12:13ǎ 12ƍ<br/>
	* 13:14ǎ 13ƍ<br/>
	* 14:15ǎ 14ƍ<br/>
	* 15:16ǎ 15ƍ
	*/
	int REDUNDANT_READING();
	/**
	* @brief xǂݖh~^C}[̐ݒ擾܂B
	* @return
	*  0: <br/>
	*  3: 50ms<br/>
	*  5:100ms<br/>
	* 10:200ms<br/>
	* 15:300ms<br/>
	* 20:400ms<br/>
	* 25:500ms<br/>
	* 30:600ms
	**/
	int MULTIPLE_READ_RESET_TIME();
	/**
	* @brief AhI^C}[̐ݒ擾܂B
	* @return   
	* 0:Ȃ  <br/>
	* 13:250ms<br/>
	* 25:500ms<br/>
	* 38:750ms
	*/
	int ADDON_WAIT_TIME();
	/**
	* @brief uU[{[̐ݒ擾܂B
	* @return   
	* 127:ő<br/> 
	*  32:<br/>
	*   8:<br/>
	*   1:
	*/
	int BUZZER_VOLUME();
	/**
	* @brief LED_Ԃ̐ݒ擾܂B
	* @return   
	* 0:<br/>
	* 10:200ms<br/>
	* 20:400ms<br/>
	* 30:600ms
	*/
	int GOOD_READ_LED_ON_TIME();
	/**
	* @brief gK[h̐ݒ擾܂B
	* @return   0:gK 1:gKL              
	*/
	int TRIGGER_MODE_ENABLE();
	/**
	* @brief gKs[g̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int TRIGGER_REPEAT_ENABLE();
	/**
	* @brief uU[̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int BUZZER_ENABLE();
	/**
	* @brief uU[g[̐ݒ擾܂B
	* @return   
	* 0:P 		<br/>
	* 1: 		<br/>
	* 2:ፂ 		<br/>
	* 3:4.5KH 	 <br/>
	* 4:2.2KHz-2KHz <br/>
	*/
	int BUZZER_TONE();
	/**
	* @brief uU[Ԃ̐ݒ擾܂B
	* @return   
	* 5:100ms <br/>
	* 10:200ms<br/> 
	* 20:400ms<br/>
	* 2:50ms
	*/
	int BUZZER_PERIOD();
	/**
	* @brief uU[^C~O̐ݒ擾܂B
	* @return   0:]OuU[ 1:]uU[
	*/
	int BUZZER_MODE();
	/**
	* @brief ڑAhX̐ݒ擾܂B
	* @return   ڑAhX
	*/
	char *DESTINATION_ADDRESS();

	/**
	* @brief F؂̐ݒ擾܂B
	* @return   0:Fؖ 1:FؗL()
	*/
	int AUTHENTICATION();
	/**
	* @brief Í̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int ENCRYPTION_ENABLE();
	/**
	* @brief R}h̐ݒ擾܂B
	* @return   1:LiACK/NAK) 0:BT33(0-7)̐ݒɏ]
	*/
	int COMMAND_RESPONSE();
	/**
	* @brief PINR[h̐ݒ擾܂B
	* @return   PINR[h
	*/
	char *PIN_CODE();
	
	/**
	* @brief gK[ɂڑ̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int TRIGGER_CONNECTION_ENABLE();
	/**
	* @brief AhXo[R[hǂݎɂڑ̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int ADDRESS_BARCODE_CONNECTION_ENABLE();
	/**
	* @brief ACK/NAK̐ݒ擾܂B
	* @return   0: 1:L 2:LiNoResponsej
	*/
	int ACK_NAK_CONTROL();
	/**
	* @brief ڑ[h̐ݒ擾܂B
	* @return   
	* 0:SPP}X^[<br/>
	* 1:SPPX[u<br/> 
	* 2:HID
	*/
	int CONNECTION_MODE();
	/**
	* @brief X[uڑ҂Ԃ̐ݒ擾܂B
	* @return   
	* 1500:30b<br/>
	* 3000:1<br/>
	* 6000:2<br/>
	* 9000:3<br/>
	* 12000:4
	*/
	int SLAVE_CONNECTION_WAIT_TIME();
	/**
	* @brief ĐڑLԂ̐ݒ擾܂B
	* @return
	* 0:<br/>
	* 3000:1<br/>
	* 6000:2<br/>
	* 9000:3<br/>
	* 12000:4<br/>
	* 15000:5<br/>
	* 18000:6<br/>
	* 21000:7<br/>
	* 24000:8<br/>
	* 27000:9<br/>
	* 30000:10<br/>
	* 33000:11<br/>
	* 36000:12<br/>
	* 39000:13<br/>
	* 42000:14<br/>
	* 45000:15
	*/
	int AUTO_RECONNECTION_TIME();
	/**
	* @brief ؒfԂ̐ݒ擾܂B
	* @return   
	* 0:<br/>
	* 30000:10<br/>
	* 60000:20<br/>
	* 90000:30<br/>
	* 120000:40<br/>
	* 150000:50<br/>
	* 180000:60<br/>
	* 3000:1<br/>
	* 6000:2<br/>
	* 9000:3<br/>
	* 12000:4<br/>
	* 15000:5<br/>
	* 18000:6<br/>
	* 21000:7<br/>
	* 24000:8<br/>
	* 27000:9<br/>
	* 500:10b<br/>
	* 1000:20b<br/>
	* 1500:30b<br/>
	* 2000:40b<br/>
	* 2500:50b
	*/
	int AUTO_DISCONNECTION_TIME();
	/**
	* @brief gKڑԂ̐ݒ擾܂B
	* @return
	* 0:gKڑ <br/>
	* 50:1b<br/> 
	* 100:2b<br/> 
	* 150:3b<br/> 
	* 200:4b<br/> 
	* 250:5b<br/> 
	* 300:6b<br/> 
	* 350:7b<br/> 
	* 400:8b<br/> 
	* 450:9b<br/>
	*/
	int TRIGGER_BUTTON_PUSHTIME_FOR_CONNECTION();
	/**
	* @brief gKؒfԂ̐ݒ擾܂B
	* @return   
	*   0:gKؒf 
	*  50:1b <br/>
	* 100:2b<br/> 
	* 150:3b<br/> 
	* 200:4b<br/> 
	* 250:5b<br/> 
	* 300:6b<br/> 
	* 350:7b<br/> 
	* 400:8b<br/> 
	* 450:9b<br/>           
	*/
	int TRIGGER_BUTTON_PUSHTIME_FOR_DISCONNECTION();
	/**
	* @brief ACK/NAK҂Ԃ̐ݒ擾܂B
	* @return   5:100ms 25:500ms 50:1s
	*/
	int ACK_NAK_WAIT_TIME();
	/**
	* @brief O[̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int OUT_OF_RANGE_MEMORY_ENABLE();
	/**
	* @brief f[^RNg̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int DATA_COLLECT_MODE_ENABLE();
	/**
	* @brief o[R[hǂݎ莩ڑ̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int AUTO_CONNECTION_ENABLE();
	/**
	* @brief f[^RN^[̐ؒfuU[̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int DISCONNECTION_BUZZER_FROM_DATA_COLLECTOR();
	/**
	* @brief ڑ肩̐ؒfuU[̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int DISCONNECTION_BUZZER_FROM_DESTINATION();
	/**
	* @brief [f[^̏o͕@̐ݒ擾܂B
	* @return   
	* 0:ڑo<br/>
	* 1:t@NVL[R}hŏo<br/> 
	*  :f[^o̓R}h                  
	*/
	int MEMORY_OUTPUT_METHOD();
	/**
	* @brief USBڑCOMʐM̐ݒ擾܂B
	* @return   0: 1:L
	*/
	int USB_CONNECTION();
	/**
	* @brief t@NVo͂̐ݒ擾܂B
	* @return   
	* 0x09:HT <br/>
	* 0x0A:LF <br/>
	* 0x0D:CR <br/>
	* 0x18:CAN<br/>
	* 0x1B:ESC<br/>
	*/
	int FUNCTION_BUTTON_INPUT();
	/**
	* @brief BluetoothfoCXi@j̐ݒ擾܂B
	* @return  BluetoothfoCX
	*/
	char *DEVICE_NAME();
	/**
	* @brief ÕX[uڑ̑AhX̐ݒ擾܂B
	* @return  ÕX[uڑ̑AhX
	*/
	char *DESTINATION_ADDRESS_LAST_TIME();
	/**
	* @brief LN^ԃfBC̐ݒ擾܂B
	* @return   
	* 0:0ms    <br/>
	* 10:10ms  <br/>
	* 20:20ms  <br/>
	* 30:30ms  <br/>
	* 40:40ms  <br/>
	* 50:50ms  <br/>
	* 60:60ms  <br/>
	* 70:70ms  <br/>
	* 80:80ms  <br/>
	* 90:90ms  <br/>
	* 100:100ms<br/>
	* 150:150ms<br/>
	* 200:200ms<br/>
	* 250:250ms<br/>
	* 300:300ms<br/>
	* 350:350ms<br/>
	* 400:400ms<br/>
	* 450:450ms<br/>
	* 500:500ms<br/>
	* 550:550ms<br/>
	* 600:600ms<br/>
	*/
	int INTER_CHARACTER_DELAY();
	/**
	* @brief L[{[h̐ݒ擾܂B
	* @return   
	* 0x01:USA(Default) <br/>
	* 0x02:UK 		   <br/>
	* 0x03:French 	   <br/>
	* 0x04:German 	   <br/>
	* 0x05:Italian     <br/>
	* 0x09:Belgian 	   <br/>
	* 0x0A:Spanish 	   <br/>
	* 0x0B:Portuguese  <br/>
	* 0x0C:Dutch 	   <br/>
	* 0x0D:Swedish	   <br/>
	* 0x0E:Finnish	   <br/>
	* 0x0F:Swiss German<br/> 
	* 0x10:Swiss French<br/> 
	* 0x11:Japanese    <br/>
	* 0x12:Danish 	   <br/>
	* 0x13:Norwegian   <br/>
	* 0x15:Czech	   <br/>
	*/
	int KEYBOARD_LANGUAGE();
	/**
	* @brief NumPadgp̐ݒ擾܂B
	* @return   
	* 0xFF:NumpbhgpȂ<br/>
	* 0x00:Numpbhgp
	*/
	int USE_NUM_PAD();
	/**
	* @brief NumPad[h̐ݒ擾܂B
	* @return   
	* 0x00:AUTO zXgNumlockL[̏Ԃɂē삷<br/>
	* 0x01:INumlockL[ĂȂԂɂ                   
	*/
	int NUM_PAD_MODE();
	/**
	* @brief CapsLock[h̐ݒ擾܂B
	* @return 
	* 0:CapsLock[h<br/>
	* 1:CapsLock[h<br/>
	* 2:CapsLock[hL
	*/
	int CAPS_LOCK_MODE();
	/**
	* @brief Obh[hoCu[^[̐ݒ擾܂B
	* @return YES:L NO:
	*/
	BOOL GOOD_READ_VIBRATOR_ENABLE();



	//--------------------------------------------------------------------------------------------------
	// Public Methods(Prefix)
	//--------------------------------------------------------------------------------------------------
	/** 
	* @brief UPC-ÃvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *UPCA_PREFIX();
	/**
	* @brief UPC-AAhĨvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *UPCA_ADDON_PREFIX();
	/** 
	* @brief UPC-ẼvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *UPCE_PREFIX();
	/** 
	* @brief UPC-EAhĨvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *UPCE_ADDON_PREFIX();
	/** 
	* @brief EAN-13̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *EAN13_PREFIX();
	/** 
	* @brief EAN-13AhĨvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *EAN13_ADDON_PREFIX();
	/** 
	* @brief EAN-8̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *EAN8_PREFIX();
	/** 
	* @brief EAN-8AhĨvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *EAN8_ADDON_PREFIX();
	/** 
	* @brief Code-39̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *CODE39_PREFIX();
	/** 
	* @brief Tri-Optic̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *TRI_OPTIC_PREFIX();
	/** 
	* @brief NW-7̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *NW7_PREFIX();
	/** 
	* @brief D.2of5̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *D2OF5_PREFIX();
	/** 
	* @brief I.2of5̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *I2OF5_PREFIX();
	/** 
	* @brief SCodẽvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *SCODE_PREFIX();
	/** 
	* @brief Matrix2of5̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *MATRIX2OF5_PREFIX();
	/** 
	* @brief Code93̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *CODE93_PREFIX();
	/** 
	* @brief Code128̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *CODE128_PREFIX();
	/** 
	* @brief MSI/PlesseỹvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *MSIPLESSEY_PREFIX();
	/** 
	* @brief IATÃvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *IATA_PREFIX();
	/** 
	* @brief UK/PlesseỹvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *UKPLESSEY_PREFIX();
	/** 
	* @brief TelepeñvtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *TELEPEN_PREFIX();
	/** 
	* @brief RSS̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *RSS_PREFIX();
	/** 
	* @brief PDF417̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *PDF417_PREFIX();
	/** 
	* @brief MicroPDF417̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *MICRO_PDF417_PREFIX();
	/** 
	* @brief Code11̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *CODE11_PREFIX();
	/** 
	* @brief Code3of5̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *CODE3OF5_PREFIX();
	/** 
	* @brief EAN-128̃vtBbNXw肵܂ 
	* @return vtBbNX
	*/
	BYTE *EAN128_PREFIX();
	/** 
	* @brief RvtBbNX w肵܂ 
	* @return vtBbNX
	*/
	BYTE *COMMON_PREFIX();

	//2D
	/** 
	* @brief Intelligent Mail̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *INTELLIGENT_MAIL_PREFIX();
	/** 
	* @brief Postnet̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *POSTNET_PREFIX();
	/** 
	* @brief Japanese postal̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *JAPANESE_POSTAL_PREFIX();
	/** 
	* @brief CodablockF̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *CODABLOCK_F_PREFIX();
	/** 
	* @brief Data Matrix(ECC200,ECC000-140)̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *DATA_MATRIX_ECC200_ECC000_140_PREFIX();
	/** 
	* @brief Aztec code/Aztec runes̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *AZTEC_CODE_RUNES_PREFIX();
	/** 
	* @brief Chinese Sensible codẽvtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *CHINESE_SENSIBLE_CODE_PREFIX();
	/** 
	* @brief QR/MicroQR̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *QR_MICRO_QR_PREFIX();
	/** 
	* @brief Maxi codẽvtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *MAXI_CODE_PREFIX();
	/** 
	* @brief Composite (on GS1Databar,UPC/EAN)̃vtBbNXw肵܂
	* @return vtBbNX
	*/
	BYTE *COMPOSITE_ON_GS1_DATABAR_ON_UPC_EAN_PREFIX();

	//--------------------------------------------------------------------------------------------------
	// Public Methods(Suffix)
	//--------------------------------------------------------------------------------------------------

	/** 
	* @brief UPC-ÃTtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *UPCA_SUFFIX();
	/** 
	* @brief UPC-AAhĨTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *UPCA_ADDON_SUFFIX();
	/** 
	* @brief UPC-ẼTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *UPCE_SUFFIX();
	/** 
	* @brief UPC-EAhĨTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *UPCE_ADDON_SUFFIX();
	/** 
	* @brief EAN-13̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *EAN13_SUFFIX();
	/** 
	* @brief EAN-13AhĨTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *EAN13_ADDON_SUFFIX();
	/** 
	* @brief EAN-8̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *EAN8_SUFFIX();
	/** 
	* @brief EAN-8AhĨTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *EAN8_ADDON_SUFFIX();
	/** 
	* @brief Code-39̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *CODE39_SUFFIX();
	/** 
	* @brief Tri-Optic̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *TRI_OPTIC_SUFFIX();
	/** 
	* @brief NW-7̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *NW7_SUFFIX();
	/** 
	* @brief D.2of5̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *D2OF5_SUFFIX();
	/** 
	* @brief I.2of5̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *I2OF5_SUFFIX();
	/** 
	* @brief SCodẽTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *SCODE_SUFFIX();
	/** 
	* @brief Matrix2of5̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *MATRIX2OF5_SUFFIX();
	/** 
	* @brief Code93̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *CODE93_SUFFIX();
	/** 
	* @brief Code128̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *CODE128_SUFFIX();
	/** 
	* @brief MSI/PlesseỹTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *MSIPLESSEY_SUFFIX();
	/** 
	* @brief IATÃTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *IATA_SUFFIX();
	/** 
	* @brief UK/PlesseỹTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *UKPLESSEY_SUFFIX();
	/** 
	* @brief TelepeñTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *TELEPEN_SUFFIX();
	/** 
	* @brief RSS̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *RSS_SUFFIX();
	/** 
	* @brief PDF417̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *PDF417_SUFFIX();
	/** 
	* @brief MicroPDF417̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *MICRO_PDF417_SUFFIX();
	/** 
	* @brief Code11̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *CODE11_SUFFIX();
	/** 
	* @brief Code3of5̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *CODE3OF5_SUFFIX();
	/** 
	* @brief EAN-128̃TtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *EAN128_SUFFIX();
	/** 
	* @brief RTtBbNXw肵܂ 
	* @return TtBbNX
	*/
	BYTE *COMMON_SUFFIX();

	//2D
	/** 
	* @brief Intelligent Mail̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *INTELLIGENT_MAIL_SUFFIX();
	/** 
	* @brief Postnet̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *POSTNET_SUFFIX();
	/** 
	* @brief Japanese postal̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *JAPANESE_POSTAL_SUFFIX();
	/** 
	* @brief CodablockF̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *CODABLOCK_F_SUFFIX();
	/** 
	* @brief Data Matrix(ECC200,ECC000-140)̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *DATA_MATRIX_ECC200_ECC000_140_SUFFIX();
	/** 
	* @brief Aztec code/Aztec runes̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *AZTEC_CODE_RUNES_SUFFIX();
	/** 
	* @brief Chinese Sensible codẽTtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *CHINESE_SENSIBLE_CODE_SUFFIX();
	/** 
	* @brief QR/MicroQR̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *QR_MICRO_QR_SUFFIX();
	/** 
	* @brief Maxi codẽTtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *MAXI_CODE_SUFFIX();
	/** 
	* @brief Composite (on GS1Databar,UPC/EAN)̃TtBbNXw肵܂
	* @return TtBbNX
	*/
	BYTE *COMPOSITE_ON_GS1_DATABAR_ON_UPC_EAN_SUFFIX();

};
#endif